<?php
class modelForum extends cmsModel {
	public function addCat($cats){		
		return $this->insert('forum_cats', $cats);
	}
	public function addForum($forum){		
		return $this->insert('forum', $forum);
	}
	public function getCat(){
		return $this->get('forum_cats');
	}
	public function getItemCat($id){
		return $this->getItemById('forum_cats', $id);
    }
	public function deletCat($id){	
	   if($this->getCatForums($id)){
	    foreach($this->getCatForums($id) as $us){
		    $this->deletForums($us['id']);
		}
	   }
		return $this->delete('forum_cats', $id);
	}
	public function updateCat($id, $cats){
		return $this->update('forum_cats', $id, $cats);
	}
	public function getForums(){
		$this->select('c.name', 'cat_title');
	    $this->join('forum_cats', 'c', 'c.id = i.cat_id');
		return $this->get('forum');
	}
    public function getCatForums($catid){
	    $this->filterEqual('cat_id', $catid);
		return $this->get('forum');
	}	
	public function getIndex(){
	    if(!$this->getCat()){return;}
		foreach($this->getCat() as $cat){
			$cat['catforum']=$this->getCatForums($cat['id']);
			$cats[]=$cat;
        }
		return $cats;
    }	
	public function deletForums($id){	
	    $forum = $this->getItemForum($id);
	    foreach($this->getForumsPost($id) as $us){
		    $this->deletPost($us['id']);
		}
		if($forum['icon']){
		$config = cmsConfig::getInstance();
		$images = self::yamlToArray($forum['icon']);
		if (is_array($images)){
			foreach($images as $path){
				@unlink( $config->upload_path . $path );
			}
		}
		}
		return $this->delete('forum', $id);
	}
    public function getItemForum($forum_id){
		return $this->getItemById('forum', $forum_id);
    }	
	public function getForumsPostCount($id){
	    $this->filterEqual('i.forum_id', $id);
       return $this->getCount('forum_post');
	}
	public function getAllPosts(){
		$this->select('u.avatar', 'u_avatar');		
		$this->select('u.is_admin', 'is_admin');		
        $this->select('u.nickname', 'user_nickname');
		$this->select('u.avatar', 'u_avatar');
	    $this->join('{users}', 'u', 'u.id = i.user_id');
		$this->join('forum_post', 't', 't.id = i.post_id');
		$this->select('t.title', 'title');
        $this->orderBy('i.pubdate', 'desc');
        $this->limit('15');		
		return $threads = $this->get('forum_posts');
	}
    public function getForumsPost($forum_id){
		$this->select("DATE_FORMAT( i.pubdate, '%d.%m.%Y' )", 'dates');
        $this->select('i.pubdate', 'date_pub');		
		$this->select('u.avatar', 'user_avatar');
		$this->select('u.nickname', 'user_nickname');
	    $this->join('{users}', 'u', 'u.id = i.user_id');
		$this->select("p.id", 'pid');
		$this->select("DATE_FORMAT( p.pubdate, '%d.%m.%Y' )", 'pdates');					
        $this->joinLeft('forum_posts', 'p', 'p.id = i.last_msg');
        $this->select('pu.nickname', 'p_nickname');
	    $this->joinLeft('{users}', 'pu', 'pu.id = p.user_id');		
	    $this->filterEqual('i.forum_id', $forum_id);	
	    $this->groupBy('i.id');   
        $this->orderBy('i.pubdate', 'desc');				
		return $this->get('forum_post');
	}	
	public function addPost($post){		
		return $this->insert('forum_post', $post);
	}
	public function addPosts($post){		
		return $this->insert('forum_posts', $post);
	}
	public function updateForum($id, $forums){
		return $this->update('forum', $id, $forums);
	}	
	public function updatePost($id, $post){
		return $this->update('forum_post', $id, $post);
	}
	public function updatePosts($id, $post){
		return $this->update('forum_posts', $id, $post);
	}
	public function getPost($id){
		return $this->getItemById('forum_post', $id);
	}
	public function deletPost($id){	
	    foreach($this->getPosts($id) as $us){
		    $this->deletPosts($us['id']);
		}
		return $this->delete('forum_post', $id);
	}
	public function deletPosts($id){	
	     $postid = $this->getPostsId($id);
		 if($postid['file']){
		        $config = cmsConfig::getInstance();
		        $file = self::yamlToArray($forum['file']);
				@unlink( $config->upload_path . $file['path'] );
		 }
		return $this->delete('forum_posts', $id);
	}
	public function getPostsId($id){
		return $this->getItemById('forum_posts', $id);
	}
	public function getPostMin($id){
		$this->select('MIN(i.id)', 'id');		
	    $this->filterEqual('i.post_id', $id);
		return $this->getItem('forum_posts');
	}
	public function getPostMax($id){
		$this->select('MAX(i.id)', 'id');		
	    $this->filterEqual('i.post_id', $id);
		return $this->getItem('forum_posts');
	}
	public function getPostsCount($id){
	    $this->filterEqual('i.post_id', $id);
       return $this->getCount('forum_posts');
	}
	public function getPosts($id,$signature=''){
		$this->select("DATE_FORMAT( i.pubdate, '%d.%m.%Y %H:%i' )", 'dates');
        $this->select('i.pubdate','date_pub');		
		$this->select("DATE_FORMAT( u.date_reg, '%d.%m.%y' )", 'regdates');	
		$this->select("DATE_FORMAT( u.date_log, '%d.%m.%y' )", 'logdates');	
		$this->select('u.avatar', 'u_avatar');		
		$this->select('u.is_admin', 'is_admin');		
        $this->select('u.nickname', 'user_nickname');
		if($signature){
        $this->select('u.'.$signature, 'signature');
		}
	    $this->join('{users}', 'u', 'u.id = i.user_id');
	    $this->select('COUNT(c.id)', 'pcount');
	    $this->join('forum_posts', 'c', 'c.user_id = u.id');
		$this->join('forum_post', 't', 't.id = i.post_id');
		$this->select('t.closed', 'closed');
	    $this->filterEqual('i.post_id', $id);
	    $this->groupBy('i.id');   
        $this->orderBy('i.pubdate', '');				
		return $this->get('forum_posts', function($post, $model){

            $post['is_online'] = cmsUser::userIsOnline($post['user_id']);

            return $post;

        });
	}
	
}